local Rect = require("structures/rect")
local Box = require("objects/box")
local player = require("objects/player")
local level = require("objects/level")
local levelManager = {
	worldData = require("assets/world")
}

function levelManager:loadLevel ()
	level.entities = {}
	level.collidableRects = {}
	
	local collisionSize = self.worldData.intsGridSize
	local collisionMapWidth = self.worldData.width / collisionSize
	for _, int in pairs(self.worldData.ints) do
		if int == 1 then
			x = (_ - 1) % collisionMapWidth
			y = math.floor((_ - 1) / collisionMapWidth)
			table.insert(level.collidableRects, Rect(x * collisionSize, y * collisionSize, collisionSize, collisionSize))
		end
	end

	for _, entity in pairs(self.worldData.entities) do
		if entity.name == "Player" then
			player.rect = Rect(entity.location[1], entity.location[2], entity.width, entity.height)
			player.velocity.x = 0
			player.velocity.y = 0
		elseif entity.name == "Box" then
			local box = Box(entity.location[1], entity.location[2], entity.width, entity.height)
			table.insert(level.entities, box)
			table.insert(level.collidableRects, box.rect)
		end
	end
end

return levelManager
