local Rect = require("structures/rect")
local Vector = require("structures/vector")
local level = {
	entities = {},
	collidableRects = {}
}

function level:update (deltaTime)
	for _, entity in pairs(self.entities) do
		entity:update(deltaTime)
	end
end

function level:draw ()
	for _, rect in pairs(self.collidableRects) do
		love.graphics.rectangle("fill", rect.x, rect.y, rect.width, rect.height)
	end
	for _, entity in pairs(self.entities) do
		entity:draw()
	end
end

return level
