-- This is a simple rect class that contains a AABB method and a method to check a table of rects and returns all overlaps.

local Object = require("libraries/classic")
local Rect = Object:extend()

function Rect:new (x, y, width, height)
	self.x = x
	self.y = y
	self.width = width
	self.height = height
end

function Rect:aabb (rect)
	return self.x < rect.x + rect.width and self.x + self.width > rect.x and self.y < rect.y + rect.height and self.height + self.y > rect.y
end

function Rect:overlaps (rects)
	local overlaps = {}
	for _, rect in pairs(rects) do
		if rect ~= self and self:aabb(rect) then
			table.insert(overlaps, rect)
		end
	end
	return overlaps
end

return Rect
